#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
################################################################################
CaseLevel         CONFORMANCE
CaseAttribute     AUTO
CaseVerboseLevel  DEFAULT
set reportfile    report.csv

#                                                                
# test case Name, category, description, GUID...
#
CaseGuid        78F8B3B6-AB67-4b82-BD6E-44396DA55ED0
CaseName        DestroyChild.Conf2.Case1
CaseCategory    ARP
CaseDescription {This case is to test the DestroyChild Conformance of ARPSB -  \
                 destroy a NULL child, ArpServiceBinding.DestroyChild should   \
                 return EFI_INVALID_PARAMETER.}
################################################################################

#
# Begin log ...
#
BeginLog

Include ARP/include/Arp.inc.tcl

set hostmac    [GetHostMac]
set targetmac  [GetTargetMac]

VifUp 0 172.16.210.162 255.255.255.0
BeginScope _ARP_SPEC_CONFORMANCE_

#
# Parameter Definition
# R_ represents "Remote EFI Side Parameter"
# L_ represents "Local ENTS Side Parameter"
#
UINTN                            R_Status
UINTN                            R_Handle

#
# Destroy a NULL child
#
ArpServiceBinding->DestroyChild {0, &@R_Status}
GetAck
set assert [VerifyReturnStatus R_Status $EFI_INVALID_PARAMETER]
RecordAssertion $assert $ArpDestroyChildConfAssertionGuid002                   \
                "Mtftp4SB.DestroyChild - Destroy NULL Child "                  \
                "ReturnStatus - $R_Status,ExpectedStatus - $EFI_INVALID_PARAMETER"
#
# Destroy un-existed child
#
ArpServiceBinding->DestroyChild {@R_Handle, &@R_Status}
GetAck
set assert [VerifyReturnStatus R_Status $EFI_INVALID_PARAMETER]
RecordAssertion $assert $ArpDestroyChildConfAssertionGuid003                   \
                "Mtftp4SB.DestroyChild - Destroy un-existed Child "            \
                "ReturnStatus - $R_Status,ExpectedStatus - $EFI_INVALID_PARAMETER"\
                
EndScope _ARP_SPEC_CONFORMANCE_
VifDown 0

#
# End Log
#
EndLog