#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
if {[info exist ARP_INC] == 1} {
  return
}
set ARP_INC 1

Include include/GenericAssertionGuid.tcl
Include EfiUtil/EfiInclude.tcl
Include include/EntsProtocolTest.inc.tcl
Include include/EfiBootService.inc.tcl
Include ARP/include/ArpAssertionGuid.tcl

Func ArpServiceBinding->CreateChild {
  POINTER
  POINTER
}

Func ArpServiceBinding->DestroyChild {
  UINTN
  POINTER
}

Func Arp->Configure {
  POINTER
  POINTER
}

Func Arp->Add {
  BOOLEAN
  POINTER
  POINTER
  UINTN
  BOOLEAN
  POINTER
  }

Func Arp->Find {
  BOOLEAN
  POINTER
  POINTER
  POINTER
  POINTER
  BOOLEAN
  POINTER
  }

Func Arp->Delete {
  BOOLEAN
  POINTER
  POINTER
  }

Func Arp->Flush {
  POINTER
  }

Func Arp->Request {
  POINTER
  UINTN
  POINTER
  POINTER
  }

Func Arp->Cancel {
  POINTER
  UINTN
  POINTER
  }

#*************************************************
# EFI_ARP_CONFIG_DATA
#*************************************************
Struct EFI_ARP_CONFIG_DATA {
  UINT16                    SwAddressType;
  UINT8                     SwAddressLength;
  POINTER                   StationAddress;
  UINT32                    EntryTimeOut;
  UINT32                    RetryCount;
  UINT32                    RetryTimeOut;
}

#*************************************************
# EFI_ARP_FIND_DATA
#*************************************************
Struct EFI_ARP_FIND_DATA {
  UINT32               Size;
  BOOLEAN              DenyFlag;
  BOOLEAN              StaticFlag;
  UINT16               HwAddressType;
  UINT16               SwAddressType;
  UINT8                HwAddressLength;
  UINT8                SwAddressLength;
}

