/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsProtoIgmp.h
    
Abstract:

    Incude header files for protocol IGMP

--*/

#ifndef __EMS_IGMP_H__
#define __EMS_IGMP_H__

#include "EmsTclInit.h"
#include "EmsTypes.h"
#include "EmsProtoIp.h"
#include "EmsProtocols.h"

#define IGMP_MEMBERSHIP_QUERY     0x11  /* membership query */
#define IGMP_V1_MEMBERSHIP_REPORT 0x12  /* Ver1 membership report */
#define IGMP_V2_MEMBERSHIP_REPORT 0x16  /* Ver2 membership report */
#define IGMP_LEAVE_GROUP          0x17  /* Leave group message */

extern PROTOCOL_ENTRY_T IgmpProtocol;

typedef struct _IGMP_HEADER {
  UINT8   IgmpType;                     /* type */
  UINT8   IgmpCode;                     /* Max response time */
  UINT16  IgmpSum;                      /* checksum */
  UINT32  IgmpGroup;                    /* host IP */
} IGMP_HEADER;

#endif
