/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsProtoTcp.h
    
Abstract:

    Incude header files for protocol TCP

--*/

#ifndef __EMS_TCP_H__
#define __EMS_TCP_H__

#include "EmsTypes.h"
#include "EmsProtocols.h"

extern PROTOCOL_ENTRY_T TcpProtocol;

typedef struct _TCP_HEADER {
  UINT16  TcpSrcPort;
  UINT16  TcpDstPort;
  UINT32  TcpSeq;
  UINT32  TcpAck;
  UINT8   TcpDataOffset;
  UINT8   TcpCtrlFlag;
  UINT16  TcpWinSize;
  UINT16  TcpChecksum;
  UINT16  TcpUrgent;
} TCP_HEADER;

#endif
