/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsLogCommand.h
    
Abstract:

    Incude header files for log command

--*/

#ifndef __EMS_LOG_COMMAND_H__
#define __EMS_LOG_COMMAND_H__

#include <tcl.h>
#include <EmsTypes.h>

VOID_P
LogTclInit (
  IN Tcl_Interp   *Interp
  )
/*++

Routine Description:

  Log related TCL initialization.

Arguments:

  Interp      - TCL intepreter.

Returns:

  None.

--*/
;

VOID_P
LogCurrentCommand (
  IN INT32        Argc,
  IN CONST84 INT8 *Argv[]
  )
/*++

Routine Description:

  Log the argumems into runtime information.

Arguments:

  Argc        - Argument counter.
  Argv        - Argument value pointer array.

Returns:

  None.

--*/
;

#endif
