/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsPktValidate.h
    
Abstract:

    Incude header files for packet validate

--*/

#ifndef __EMS_VALIDATE_H__
#define __EMS_VALIDATE_H__

#include "EmsTclInit.h"

#define EXPR_MAX_LEN  256

#define HIGHP         1
#define LOWP          2
#define ERRP          3
#define EQUAP         0

#define IsDigit(c)    (c >= '0' && c <= '9')

typedef struct _OPERATOR_T {
  INT8  *Name;
} OPERATOR_T;

VOID_P
ValidateTclInit (
  Tcl_Interp *Interp
  )
/*++

Routine Description:

  Packet validation related TCL command initialization routine

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

#endif
