@echo %DEBUG% OFF
rem ++
rem  Copyright (c) 2008, Intel Corporation
rem  All rights reserved. 
rem 
rem  This UEFI SCT ("Software") is furnished under license and may only be used or copied
rem  in accordance with the terms of that license UEFI Contributor Agreement.
rem  No license, express or implied, by estoppel or otherwise, to any intellectual property
rem  rights is granted by this document. The Software is subject to change without notice,
rem  and should not be construed as a commitment by Intel Corporation to market, license,
rem  sell or support any product or technology. Unless otherwise provided for in the license
rem  under which this Software is provided, the Software is provided AS IS, with no warranties
rem  of any kind, express or implied. Except as expressly permitted by the Software license,
rem  neither Intel Corporation nor its suppliers assumes any responsibility or liability
rem  for any errors or inaccuracies that may appear herein.
rem --
@echo %DEBUG% OFF

rem /*++
rem 
rem Module Name:
rem
rem   CommonGenFramework.bat
rem
rem Abstract:
rem
rem   Common part for generating the test package
rem
rem --*/

set ProcessorType=%2
set Installer=%3

set Framework=SctPackage\%ProcessorType%

rem *********************************************
rem Create target directory
rem *********************************************

if exist %Framework% (
  rmdir /s /q %Framework%
)

mkdir %Framework%
mkdir %Framework%\Data
mkdir %Framework%\Dependency
mkdir %Framework%\Support
mkdir %Framework%\Test
mkdir %Framework%\Sequence
mkdir %Framework%\Report
mkdir %Framework%\Application
mkdir %Framework%\Proxy
mkdir %Framework%\Ents\Support
mkdir %Framework%\Ents\Test

mkdir %Framework%\SCRT
copy %ProcessorType%\SCRTDriver.efi           %Framework%\SCRT            > NUL
copy %ProcessorType%\SCRTApp.efi              %Framework%\SCRT            > NUL
copy ..\..\..\Config\Data\SCRT.conf           %Framework%\SCRT            > NUL

rem *********************************************
rem Copy the SCT framework and the related application
rem *********************************************

copy %ProcessorType%\SCT.efi              %Framework%\            > NUL

copy %ProcessorType%\StandardTest.efi     %Framework%\Support\    > NUL
copy %ProcessorType%\TestProfile.efi      %Framework%\Support\    > NUL
copy %ProcessorType%\TestRecovery.efi     %Framework%\Support\    > NUL
copy %ProcessorType%\TestLogging.efi      %Framework%\Support\    > NUL

copy ..\..\..\Config\Script\SctStartup.nsh   SctPackage\             > NUL
copy %ProcessorType%\InstallSct.efi       SctPackage\%Installer%  > NUL
copy %ProcessorType%\StallForKey.efi      %Framework%\            > NUL

rem *********************************************
rem Copy the SCT configuration data
rem *********************************************

copy ..\..\..\Config\Data\Category.ini       %Framework%\Data\       > NUL
copy ..\..\..\Config\Data\GuidFile.txt       %Framework%\Data\       > NUL

rem *********************************************
rem For UEFI SCT
rem *********************************************

if %1. EQU uefi_sct. (
rem *********************************************
rem Copy the UEFI 2.0 Test Cases
rem *********************************************

copy %ProcessorType%\EfiCompliantBbTest.efi                   %Framework%\Test\ > NUL

copy %ProcessorType%\EventTimerTaskPriorityServicesBbTest.efi %Framework%\Test\ > NUL
copy %ProcessorType%\MemoryAllocationServicesBbTest.efi       %Framework%\Test\ > NUL
copy %ProcessorType%\ProtocolHandlerServicesBbTest.efi        %Framework%\Test\ > NUL
copy %ProcessorType%\ImageServicesBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\MiscBootServicesBbTest.efi               %Framework%\Test\ > NUL

copy %ProcessorType%\VariableServicesBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\TimeServicesBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\MiscRuntimeServicesBbTest.efi            %Framework%\Test\ > NUL

copy %ProcessorType%\BisBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\BlockIoBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\BusSpecificDriverOverrideBbTest.efi      %Framework%\Test\ > NUL
copy %ProcessorType%\ComponentNameBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\ComponentName2BbTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\DebugPortBbTest.efi                      %Framework%\Test\ > NUL
copy %ProcessorType%\DebugSupportBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\DecompressBbTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DeviceIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathBBTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathUtilitiesBBTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathToTextBBTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathFromTextBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\DiskIoBbTest.efi                         %Framework%\Test\ > NUL
copy %ProcessorType%\DriverDiagnosticsBbTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\DriverConfigurationBbTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\EbcBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\LoadedImageBbTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\LoadFileBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\PciIoBbTest.efi                          %Framework%\Test\ > NUL
copy %ProcessorType%\PciRootBridgeIoBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\PlatformDriverOverrideBbTest.efi         %Framework%\Test\ > NUL
copy %ProcessorType%\PxeBaseCodeBbTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\ScsiPassThruBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\ScsiIoBbTest.efi                         %Framework%\Test\ > NUL
copy %ProcessorType%\ExtScsiPassThruBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\iScsiInitiatorNameBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\SerialIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleFileSystemBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleNetworkBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimplePointerBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextInBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextOutBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\UgaDrawBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\GraphicsOutputBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\UnicodeCollationBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\UsbHcTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\UsbIoTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\Usb2HcTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\AuthenticationBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\HashBBTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\TapeBBTest.efi                           %Framework%\Test\ > NUL

rem *********************************************
rem Copy ENTS binary
rem *********************************************

copy %ProcessorType%\SerialMonitor.efi                %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\MNPMonitor.efi                   %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\IP4Monitor.efi                   %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\Eftp.efi                         %Framework%\Ents\Support\ > NUL

copy %ProcessorType%\BootService_ENTSTest.efi         %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\RuntimeService_ENTSTest.efi      %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\GenericService_ENTSTest.efi      %Framework%\Ents\Test\    > NUL

copy %ProcessorType%\SimpleNetwork_ENTSTest.efi       %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\PXEBaseCode_ENTSTest.efi         %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Mnp*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Arp*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Ip4*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Udp4*_ENTSTest.efi               %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Dhcp4*_ENTSTest.efi              %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Mtftp4*_ENTSTest.efi             %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Tcp4*_ENTSTest.efi               %Framework%\Ents\Test\    > NUL

rem *********************************************
rem Copy the test dependency files
rem *********************************************

call :CopyDependency EfiCompliant
call :CopyDependency ProtocolHandlerServices
call :CopyDependency ImageServices
call :CopyDependency Decompress
call :CopyDependency DeviceIo
call :CopyDependency Ebc
call :CopyDependency LoadedImage
call :CopyDependency PciIo
call :CopyDependency PciRootBridgeIo
call :CopyDependency PxeBaseCode
)

rem *********************************************
rem For UEFI21 SCT
rem *********************************************

if %1. EQU uefi21_sct. (
rem *********************************************
rem Copy the UEFI 2.1 Test Cases
rem *********************************************

copy %ProcessorType%\EfiCompliantBbTest.efi                   %Framework%\Test\ > NUL

copy %ProcessorType%\EventTimerTaskPriorityServicesBbTest.efi %Framework%\Test\ > NUL
copy %ProcessorType%\MemoryAllocationServicesBbTest.efi       %Framework%\Test\ > NUL
copy %ProcessorType%\ProtocolHandlerServicesBbTest.efi        %Framework%\Test\ > NUL
copy %ProcessorType%\ImageServicesBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\MiscBootServicesBbTest.efi               %Framework%\Test\ > NUL

copy %ProcessorType%\VariableServicesBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\TimeServicesBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\MiscRuntimeServicesBbTest.efi            %Framework%\Test\ > NUL

copy %ProcessorType%\BisBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\BlockIoBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\BusSpecificDriverOverrideBbTest.efi      %Framework%\Test\ > NUL
rem copy %ProcessorType%\ComponentNameBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\DebugPortBbTest.efi                      %Framework%\Test\ > NUL
copy %ProcessorType%\DebugSupportBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\DecompressBbTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DeviceIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathBBTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathUtilitiesBBTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathToTextBBTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathFromTextBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\DiskIoBbTest.efi                         %Framework%\Test\ > NUL
rem copy %ProcessorType%\DriverDiagnosticsBbTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\DriverConfigurationBbTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\EbcBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\LoadedImageBbTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\LoadFileBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\PciIoBbTest.efi                          %Framework%\Test\ > NUL
copy %ProcessorType%\PciRootBridgeIoBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\PlatformDriverOverrideBbTest.efi         %Framework%\Test\ > NUL
copy %ProcessorType%\PxeBaseCodeBbTest.efi                    %Framework%\Test\ > NUL
rem copy %ProcessorType%\ScsiPassThruBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\ScsiIoBbTest.efi                         %Framework%\Test\ > NUL
copy %ProcessorType%\ExtScsiPassThruBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\iScsiInitiatorNameBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\SerialIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleFileSystemBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleNetworkBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimplePointerBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextInBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextOutBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\UgaDrawBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\GraphicsOutputBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\UnicodeCollation2BbTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\UsbHcTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\UsbIoTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\Usb2HcTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\AuthenticationBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\HashBBTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\TapeBBTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\AcpiTableProtocolBBTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextInputExBBTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\ComponentName2BbTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\DriverDiagnostics2BbTest.efi             %Framework%\Test\ > NUL

copy %ProcessorType%\HIIDatabaseBBTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\HIIStringBBTest.efi                      %Framework%\Test\ > NUL
copy %ProcessorType%\HIIFontBBTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\HIIImageBBTest.efi                       %Framework%\Test\ > NUL

copy %ProcessorType%\AbsolutePointerBBTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\DriverSupportedEfiVersionBBTest.efi      %Framework%\Test\ > NUL
copy %ProcessorType%\PlatformToDriverConfigurationBBTest.efi  %Framework%\Test\ > NUL

copy %ProcessorType%\HIIConfigAccessBBTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\HIIConfigRoutingBBTest.efi               %Framework%\Test\ > NUL
rem *********************************************
rem Copy ENTS binary
rem *********************************************

copy %ProcessorType%\SerialMonitor.efi                %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\MNPMonitor.efi                   %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\IP4Monitor.efi                   %Framework%\Ents\Support\ > NUL
copy %ProcessorType%\Eftp.efi                         %Framework%\Ents\Support\ > NUL

copy %ProcessorType%\BootService_ENTSTest.efi         %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\RuntimeService_ENTSTest.efi      %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\GenericService_ENTSTest.efi      %Framework%\Ents\Test\    > NUL

copy %ProcessorType%\SimpleNetwork_ENTSTest.efi       %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\PXEBaseCode_ENTSTest.efi         %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Mnp*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Arp*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Ip4*_ENTSTest.efi                %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Udp4*_ENTSTest.efi               %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Dhcp4*_ENTSTest.efi              %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Mtftp4*_ENTSTest.efi             %Framework%\Ents\Test\    > NUL
copy %ProcessorType%\Tcp4*_ENTSTest.efi               %Framework%\Ents\Test\    > NUL

rem *********************************************
rem Copy the test dependency files
rem *********************************************

call :CopyDependency EfiCompliant
call :CopyDependency ProtocolHandlerServices
call :CopyDependency ImageServices
call :CopyDependency Decompress
call :CopyDependency DeviceIo
call :CopyDependency Ebc
call :CopyDependency LoadedImage
call :CopyDependency PciIo
call :CopyDependency PciRootBridgeIo
call :CopyDependency PxeBaseCode
)

rem *********************************************
rem For IHV SCT
rem *********************************************

if %1. EQU ihv_sct. (
  rem *********************************************
  rem Copy the EFI 1.10 Test Cases for IHV
  rem *********************************************

  copy %ProcessorType%\IhvBlockIoBbTest.efi                     %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvComponentNameBbTest.efi               %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvComponentName2BbTest.efi              %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvBusSpecificDriverOverrideBbTest.efi   %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDeviceIoBbTest.efi                    %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDevicePathBbTest.efi                  %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDiskIoBbTest.efi                      %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDriverBindingBbTest.efi               %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDriverConfigurationBbTest.efi         %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDriverDiagnosticsBbTest.efi           %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDriverDiagnostics2BbTest.efi          %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvEbcBbTest.efi                         %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvPlatformDriverOverrideBbTest.efi      %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvPxeBaseCodeBbTest.efi                 %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvScsiPassThruBbTest.efi                %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSerialIoBbTest.efi                    %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimpleFileSystemBbTest.efi            %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimpleNetworkBbTest.efi               %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimplePointerBbTest.efi               %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimpleTextInBbTest.efi                %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimpleTextInputExBBTest.efi           %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvSimpleTextOutBbTest.efi               %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvGraphicsOutputBBTest.efi              %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvExtScsiPassThruBbTest.efi             %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvScsiIoBBTest.efi                      %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUgaDrawBbTest.efi                     %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUnicodeCollationBbTest.efi            %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUnicodeCollation2BbTest.efi           %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUsbHcTest.efi                         %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUsbIoTest.efi                         %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvUsb2HcTest.efi                        %Framework%\Test\ > NUL
  copy %ProcessorType%\IhviScsiInitiatorNameBBTest.efi          %Framework%\Test\ > NUL

  rem *********************************************
  rem Copy the UEFI 2.1 Test Cases for IHV
  rem *********************************************

  copy %ProcessorType%\IhvAbsolutePointerBBTest.efi             %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvDriverSupportedEfiVersionBBTest.efi   %Framework%\Test\ > NUL
  copy %ProcessorType%\IhvPlatformToDriverConfigurationBBTest.efi  %Framework%\Test\ > NUL
  
  rem *********************************************
  rem Copy the test dependency files
  rem *********************************************

  call :CopyDependency DeviceIo
  call :CopyDependency Ebc
  call :CopyDependency PxeBaseCode
)

if %1. EQU efi_sct. (
rem *********************************************
rem Copy the UEFI 2.0 Test Cases
rem *********************************************

copy %ProcessorType%\EfiCompliantBbTest.efi                   %Framework%\Test\ > NUL

copy %ProcessorType%\EventTimerTaskPriorityServicesBbTest.efi %Framework%\Test\ > NUL
copy %ProcessorType%\MemoryAllocationServicesBbTest.efi       %Framework%\Test\ > NUL
copy %ProcessorType%\ProtocolHandlerServicesBbTest.efi        %Framework%\Test\ > NUL
copy %ProcessorType%\ImageServicesBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\MiscBootServicesBbTest.efi               %Framework%\Test\ > NUL

copy %ProcessorType%\VariableServicesBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\TimeServicesBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\MiscRuntimeServicesBbTest.efi            %Framework%\Test\ > NUL

copy %ProcessorType%\BisBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\BlockIoBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\BusSpecificDriverOverrideBbTest.efi      %Framework%\Test\ > NUL
copy %ProcessorType%\ComponentNameBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\DebugPortBbTest.efi                      %Framework%\Test\ > NUL
copy %ProcessorType%\DebugSupportBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\DecompressBbTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DeviceIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathBBTest.efi                     %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathUtilitiesBBTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathToTextBBTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\DevicePathFromTextBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\DiskIoBbTest.efi                         %Framework%\Test\ > NUL
copy %ProcessorType%\DriverDiagnosticsBbTest.efi              %Framework%\Test\ > NUL
copy %ProcessorType%\DriverConfigurationBbTest.efi            %Framework%\Test\ > NUL
copy %ProcessorType%\EbcBbTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\LoadedImageBbTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\LoadFileBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\PciIoBbTest.efi                          %Framework%\Test\ > NUL
copy %ProcessorType%\PciRootBridgeIoBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\PlatformDriverOverrideBbTest.efi         %Framework%\Test\ > NUL
copy %ProcessorType%\PxeBaseCodeBbTest.efi                    %Framework%\Test\ > NUL
copy %ProcessorType%\ScsiPassThruBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\ScsiIoBbTest.efi                         %Framework%\Test\ > NUL
copy %ProcessorType%\ExtScsiPassThruBbTest.efi                %Framework%\Test\ > NUL
copy %ProcessorType%\iScsiInitiatorNameBBTest.efi             %Framework%\Test\ > NUL
copy %ProcessorType%\SerialIoBbTest.efi                       %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleFileSystemBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleNetworkBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimplePointerBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextInBbTest.efi                   %Framework%\Test\ > NUL
copy %ProcessorType%\SimpleTextOutBbTest.efi                  %Framework%\Test\ > NUL
copy %ProcessorType%\UgaDrawBbTest.efi                        %Framework%\Test\ > NUL
copy %ProcessorType%\GraphicsOutputBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\UnicodeCollationBbTest.efi               %Framework%\Test\ > NUL
copy %ProcessorType%\UsbHcTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\UsbIoTest.efi                            %Framework%\Test\ > NUL
copy %ProcessorType%\Usb2HcTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\AuthenticationBBTest.efi                 %Framework%\Test\ > NUL
copy %ProcessorType%\HashBBTest.efi                           %Framework%\Test\ > NUL
copy %ProcessorType%\TapeBBTest.efi                           %Framework%\Test\ > NUL

rem *********************************************
rem Copy the test dependency files
rem *********************************************

call :CopyDependency EfiCompliant
call :CopyDependency ProtocolHandlerServices
call :CopyDependency ImageServices
call :CopyDependency Decompress
call :CopyDependency DeviceIo
call :CopyDependency Ebc
call :CopyDependency LoadedImage
call :CopyDependency PciIo
call :CopyDependency PciRootBridgeIo
call :CopyDependency PxeBaseCode
)

echo DONE!
goto :EOF


rem *********************************************
rem Copy the test dependency files for each test
rem *********************************************

:CopyDependency

mkdir %Framework%\Dependency\%1BbTest

dir /b %ProcessorType%\%1_*.       > temp.txt 2>NUL
dir /b %ProcessorType%\%1_*.efi   >> temp.txt 2>NUL
dir /b %ProcessorType%\%1_*.ini   >> temp.txt 2>NUL
dir /b %ProcessorType%\%1_*.cmp   >> temp.txt 2>NUL
dir /b %ProcessorType%\%1_*.ucmp  >> temp.txt 2>NUL

for /F "tokens=*" %%i in (temp.txt) do (
  call :CopyDependencyFile %1 %%i
)

del /f temp.txt >NUL

goto :EOF


rem *********************************************
rem Copy each test dependency file
rem *********************************************

:CopyDependencyFile

setlocal

set Source=%2
set Target=%Source:*_=%

copy %ProcessorType%\%Source%     %Framework%\Dependency\%1BbTest\%Target%  > NUL

endlocal

goto :EOF
