/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Copyright (c) 2006, Intel Corporation
All rights reserved. 

This UEFI SCT ("Software") is furnished under license and may only be used or copied
in accordance with the terms of that license UEFI Contributor Agreement.
No license, express or implied, by estoppel or otherwise, to any intellectual property
rights is granted by this document. The Software is subject to change without notice,
and should not be construed as a commitment by Intel Corporation to market, license,
sell or support any product or technology. Unless otherwise provided for in the license
under which this Software is provided, the Software is provided AS IS, with no warranties
of any kind, express or implied. Except as expressly permitted by the Software license,
neither Intel Corporation nor its suppliers assumes any responsibility or liability
for any errors or inaccuracies that may appear herein. 

Module Name:
  GenericServiceENTSTestCase.c

Abstract:

--*/

#include "GenericServiceENTSTestCase.h"

//
// MemCmp
//
static VOID     *GSMemCmpMemOne;
static VOID     *GSMemCmpMemTwo;
static UINTN    GSMemCmpLength;
static INTN     *GSMemCmpResult;

ENTS_ARG_FIELD  gGSMemCmpArgField[] = {
  {
    POINTER,
    &GSMemCmpMemOne
  },
  {
    POINTER,
    &GSMemCmpMemTwo
  },
  {
    OCTETN,
    &GSMemCmpLength
  },
  {
    POINTER,
    &GSMemCmpResult
  },
  0
};

EFI_STATUS
GS_MemCmp_EntsTest (
  VOID *ClientInterface
  )
/*++

Routine Description:

  MemCmp Ents test entry point.

Arguments:

  ClientInterface - RPC calling interface.

Returns:

  EFI_SUCCESS - Operation succeeded.

--*/
{
  *GSMemCmpResult = 0;

  for (; GSMemCmpLength > 0; GSMemCmpLength--) {
    *GSMemCmpResult = (INTN) (*(INT8 *) GSMemCmpMemOne -*(INT8 *) GSMemCmpMemTwo);
    if (*GSMemCmpResult != 0) {
      return EFI_SUCCESS;
    }

    GSMemCmpMemOne  = (VOID *) ((UINTN) GSMemCmpMemOne + 1);
    GSMemCmpMemTwo  = (VOID *) ((UINTN) GSMemCmpMemTwo + 1);
  }

  return EFI_SUCCESS;
}
