/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  AuthenticationBBTestMain.h

Abstract:

  Test Driver of Authentication Protocol

--*/

#ifndef __EFI_LOAD_FILE_TEST_H__
#define __EFI_LOAD_FILE_TEST_H__


#include "Efi.h"
#include "AuthenticationGuid.h"
#include "EfiTest.h"
#include "EfiTypes.h"


#include EFI_PROTOCOL_DEFINITION(DebugAssert)

#include "EfiTestUtilityLib.h"
#include "EfiDriverLib.h"
#include "EfiTestLib.h"
#include "EfiCommonLib.h"

#include EFI_TEST_PROTOCOL_DEFINITION (BBTest)
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestLoggingLibrary)

#define AUTH_TEST_REVISION 0x00010000

#define AUTH_FUNCTION_TEST_GUID \
  {0x31248836, 0xca1b, 0x4004, 0xab, 0x7e, 0x39, 0xea, 0x5f, 0x2, 0x46, 0xe7}
  

EFI_STATUS
InitializeAuthenticationTest (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  );

EFI_STATUS
UnloadAuthenticationTest (
  IN EFI_HANDLE       ImageHandle
  );

EFI_STATUS
BBTestAuthenticationFunctionTestA (
  IN EFI_BB_TEST_PROTOCOL             *This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestAuthenticationFunctionTestB(
  IN EFI_BB_TEST_PROTOCOL             *This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

VOID
AuthenticationTestWaitForAnyInput (
  );

#endif
