/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/


#define EFI_BROWSER_ACTION_REQUEST_NONE    0
#define EFI_BROWSER_ACTION_REQUEST_RESET   1
#define EFI_BROWSER_ACTION_REQUEST_SUBMIT  2
#define EFI_BROWSER_ACTION_REQUEST_EXIT    3

#define EFI_BROWSER_ACTION_REQUEST_CHANGING  0
#define EFI_BROWSER_ACTION_REQUEST_CHANGED   1
 
typedef CHAR16  *EFI_STRING;
typedef UINT16  EFI_STRING_ID;

typedef UINTN   EFI_BROWSER_ACTION;
typedef UINT16  EFI_QUESTION_ID;
typedef UINTN   EFI_BROWSER_ACTION_REQUEST;

/*
typedef struct {
  UINT8 Hour;
  UINT8 Minute;
  UINT8 Second;
} EFI_HII_TIME;

typedef struct {
  UINT16 Year;
  UINT8  Month;
  UINT8  Day;
} EFI_HII_DATE;

typedef union {
  UINT8           u8;
  UINT16          u16;
  UINT32          u32;
  UINT64          u64;
  BOOLEAN         b;
  EFI_HII_TIME    time;
  EFI_HII_DATE    date;
  EFI_STRING_ID   string;
} EFI_IFR_TYPE_VALUE;
*/
  
EFI_FORWARD_DECLARATION (EFI_HII_CONFIG_ACCESS_PROTOCOL);

typedef
EFI_STATUS
(EFIAPI *EFI_HII_ACCESS_EXTRACT_CONFIG ) (
IN CONST EFI_HII_CONFIG_ACCESS_PROTOCOL    *This,
IN CONST EFI_STRING                        Request,
OUT EFI_STRING                             *Progress,
OUT EFI_STRING                             *Results
);


typedef
EFI_STATUS
(EFIAPI *EFI_HII_ACCESS_ROUTE_CONFIG ) (
IN CONST EFI_HII_CONFIG_ACCESS_PROTOCOL    *This,
IN CONST EFI_STRING                        Configuration,
OUT EFI_STRING                             *Progress
);


typedef
EFI_STATUS
(EFIAPI *EFI_HII_ACCESS_FORM_CALLBACK) (
IN CONST EFI_HII_CONFIG_ACCESS_PROTOCOL    *This,
IN EFI_BROWSER_ACTION                      *Action,
IN EFI_QUESTION_ID                         QuestionId,
IN UINT8                                   Type,
IN EFI_IFR_TYPE_VALUE                      *Value,
OUT EFI_BROWSER_ACTION_REQUEST             *ActionRequest
);

//
// Interface structure for the HII Configuration Access Protocol
//

typedef struct  _EFI_HII_CONFIG_ACCESS_PROTOCOL {
EFI_HII_ACCESS_EXTRACT_CONFIG  ExtractConfig;
EFI_HII_ACCESS_ROUTE_CONFIG    RouteConfig;
EFI_HII_ACCESS_FORM_CALLBACK   CallBack;
} EFI_HII_CONFIG_ACCESS_PROTOCOL;