/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  TapeTest.h

Abstract:

  Some definitions for TapeIo test driver

--*/

#ifndef _TAPE_TEST_H
#define _TAPE_TEST_H

#include "Tiano.h"
#include "EfiDriverLib.h"
#include "EfiTestUtilityLib.h"
#include "EfiDriverLib.h"
#include "EfiTestLib.h"
#include "EfiCommonLib.h"
#include EFI_PROTOCOL_DEFINITION(DebugAssert)

#include EFI_TEST_PROTOCOL_DEFINITION (BBTest)
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)
#include EFI_TEST_PROTOCOL_DEFINITION (TestLoggingLibrary)

#include "Tape.h"

//
// Function prototypes
//
EFI_STATUS
BBTestTapeFunctionRead (
  IN EFI_BB_TEST_PROTOCOL             *_This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestTapeFunctionWrite (
  IN EFI_BB_TEST_PROTOCOL             *_This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestTapeFunctionRewind (
  IN EFI_BB_TEST_PROTOCOL             *_This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestTapeFunctionSpace (
  IN EFI_BB_TEST_PROTOCOL             *_This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestTapeFunctionWriteFM (
  IN EFI_BB_TEST_PROTOCOL             *This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );

EFI_STATUS
BBTestTapeFunctionReset (
  IN EFI_BB_TEST_PROTOCOL             *This,
  IN VOID                             *ClientInterface,
  IN EFI_TEST_LEVEL                   TestLevel,
  IN EFI_HANDLE                       SupportHandle
  );
  
extern void TapeTestWaitForAnyInput (void);
//#define _TestWaitForAnyInput() TapeTestWaitForAnyInput()

#define my_printf(x)  Print	x
#define my_logMsgPrintf  Print

#define malloc EfiLibAllocatePool 
#define free   gBS->FreePool


#define logMsg(_guid,_title,_message,_result,_maskRes) \
  StandardLib->RecordAssertion (StandardLib,\
                    ( (_maskRes==_result) ? EFI_TEST_ASSERTION_PASSED : EFI_TEST_ASSERTION_FAILED ),\
                   _guid,\
                   L"EFI Tape IO Protocol Testing ",\
                   L" - %a\n  %a\n  %a:%d\n  Status(0x%x) - %r",\
                   _title, _message, \
                   __FILE__, (UINTN)__LINE__,\
                   _result, ( (_maskRes==_result) ? EFI_SUCCESS : EFI_UNSUPPORTED )\
                   );
//#undef logMsg
//#define logMsg(_guid,_title,_message,_result,_maskRes)  
#define LogEnterFunction 	LoggingLib->EnterFunction   
#define LogExitFunction 	LoggingLib->ExitFunction                 


#endif
