/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  EftpImplement.h

Abstract:

  Eftp implementation declaration.

--*/

#ifndef _EFTP_IMPLEMENT_H_
#define _EFTP_IMPLEMENT_H_

//
// 5M Octets for initialization
//
#define MAX_REAL_FILE_SIZE          10485760
#define EFTP_DEFAULT_TIMEOUT_VALUE  3
#define EFTP_DEFAULT_RETRY_VALUE    5
#define MAX_FILENAME_LEN            50
#define MAX_MODE_STR_LEN            10

//
// External functions declarations
//
EFI_STATUS
EftpDispatchFileTransferComd (
  ENTS_CMD_TYPE Operation
  )
/*++

Routine Description:

  Dispatch an get_file command, download file from SCT management side.

Arguments:

  Operation - Operation type, defined in ENTS_CMD_TYPE.

Returns:

  EFI_SUCCESS           - Operation succeeded.
  EFI_UNSUPPORTED       - File was not supported.
  Others                - Some failure happened.

--*/
;

#endif
