/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  RivlCall.h

Abstract:

  Remote Interface Validation Language Call definitions

--*/

#ifndef __RIVL_CALL_H__
#define __RIVL_CALL_H__

#include "Rivl.h"

#define ENTS_STACK_NUM  12

typedef struct {
  UINTN Number;
  UINTN *StackTop;
  UINTN *StackBottom;
  VOID  *FuncAddr;
  UINTN CallingType;
  UINTN Status;
  UINTN Stack[ENTS_STACK_NUM];
} RIVL_CALL_FRAME;

UINTN
RivlCall (
  VOID  *FuncAddr,
  UINTN CallingType,
  UINTN Number,
  UINTN *StackTop,
  UINTN *StackBottom
  )
/*++

Routine Description:

  Remote Interface verification calling.

Arguments:

  FuncAddr    - Remote calling function address.
  CallingType - Calling type.
  Number      - Calling number.
  StackTop    - Top stack.
  StackBottom - Bottom stack.

Returns:

  

--*/
;

#endif // __RIVL_CALL_H__
