/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  ApTest.h

Abstract:

  This file defines a protocol interface for Application Test.

--*/

#ifndef _EFI_AP_TEST_H_
#define _EFI_AP_TEST_H_

//
// Includes
//

#include "Efi.h"
#include "EfiTest.h"
#include EFI_TEST_PROTOCOL_DEFINITION (StandardTestLibrary)

//
// EFI Application Test Interface definitions
//

#define EFI_AP_TEST_REVISION            0x00010000

//
// Forward reference for pure ANSI compatibility
//

EFI_FORWARD_DECLARATION (EFI_AP_TEST_ENTRY);

//
// EFI Application Test Entry Point
//

typedef struct _EFI_AP_TEST_ENTRY {
  EFI_AP_TEST_ENTRY     *Next;
  EFI_GUID              EntryId;
  CHAR16                *Name;
  CHAR16                *Description;
  UINT32                TestLevelSupportMap;
  EFI_GUID              *SupportProtocols;
  UINT32                CaseAttribute;
  CHAR16                *Parameters;
} EFI_AP_TEST_ENTRY;

//
// EFI Application Test Interface
//

typedef struct {
  UINT64                TestRevision;
  EFI_GUID              CategoryGuid;
  CHAR16                *Name;
  CHAR16                *Description;
  EFI_AP_TEST_ENTRY     *EntryList;
} EFI_AP_TEST_INTERFACE;

#endif
